import enum Engine.HTTPBody
import protocol Engine.HTTPBodyRepresentable

extension HTTPBody {
    public init(_ json: JSON) throws {
        let bytes = try JSON.serialize(json)
        self.init(bytes)
    }
}

extension JSON: HTTPBodyRepresentable {
    public func makeBody() -> HTTPBody {
        if let body = try? HTTPBody(self) { return body }
        else { return .data([]) }
    }
}
